import numpy as np
import pystencils as ps
from pystencils_benchmark.gpu.benchmark import kernel_header, _add_launch_bound, kernel_source


def test_launch_bounds():
    a, b, c = ps.fields(a=np.ones(4000000), b=np.ones(4000000), c=np.ones(4000000))

    @ps.kernel_config(ps.CreateKernelConfig(target=ps.Target.GPU))
    def vadd():
        a[0] @= b[0] + c[0]
    kernel_vadd = ps.create_kernel(**vadd)
    launch_bounds = (256, 2)
    header = kernel_header(kernel_vadd)
    header = _add_launch_bound(header, launch_bounds)
    assert "void __launch_bounds__(256, 2)" in header
    source = kernel_source(kernel_vadd)
    source = _add_launch_bound(source, launch_bounds)
    assert "void __launch_bounds__(256, 2)" in source 
